// Bit mask definitions
#define BIT0   (1)
#define BIT1   (1 << 1)
#define BIT2   (1 << 2)
#define BIT3   (1 << 3)
#define BIT4   (1 << 4)
#define BIT5   (1 << 5)
#define BIT6   (1 << 6)
#define BIT7   (1 << 7)

#define BIT8   (1 << 8)
#define BIT9   (1 << 9)
#define BIT10  (1 << 10)
#define BIT11  (1 << 11)
#define BIT12  (1 << 12)
#define BIT13  (1 << 13)
#define BIT14  (1 << 14)
#define BIT15  (1 << 15)

#define BIT16  (1 << 16)
#define BIT17  (1 << 17)
#define BIT18  (1 << 18)
#define BIT19  (1 << 19)
#define BIT20  (1 << 20)
#define BIT21  (1 << 21)
#define BIT22  (1 << 22)
#define BIT23  (1 << 23)

#define BIT24  (1 << 24)
#define BIT25  (1 << 25)
#define BIT26  (1 << 26)
#define BIT27  (1 << 27)
#define BIT28  (1 << 28)
#define BIT29  (1 << 29)
#define BIT30  (1 << 30)
#define BIT31  (1 << 31)

// gpio port stuff
#define P9DIR  (*(int *)(0x5800F400))
#define P9LSB  (*(int *)(0x5800F004))

// System control unit stuff
#define SCU_CLKCNTR (*(int *)(0x5C002000))
#define SCU_PCGR0 (*(int *)(0x5C002014))
#define SCU_PCGR1 (*(int *)(0x5C002018))
#define SCU_PRR0 (*(int *)(0x5C00201C))
#define SCU_PRR1 (*(int *)(0x5C002020))
#define SCU_PECGR1 (*(int *)0x5C002030))
#define SCU_SCR1 (*(int *)0x5C002038))
// timer stuff
#define TIM_ICR1 (*(int *)(0x58002000))
#define TIM_ICR2 (*(int *)(0x58002004))
#define TIM_OC1R (*(int *)(0x58002008))
#define TIM_OC2R (*(int *)(0x5800200C))
#define TIM_CNTR (*(int *)(0x58002010))
#define TIM_CR1  (*(int *)(0x58002014))
#define TIM_CR2  (*(int *)(0x58002018))
#define TIM_SR   (*(int *)(0x5800201C))
// VIC stuff
#define VIC0_ISR (*(int *)(0xFFFFF000))
#define VIC0_INTSR (*(int *)(0xFFFFF00C))
#define VIC0_INTER (*(int *)(0xFFFFF010))
#define VIC0_INTECR (*(int *)(0xFFFFF014))
#define VIC0_SWINTR (*(int *)(0xFFFFF018))
#define VIC0_SWINTCR (*(int *)(0xFFFFF01C))
#define VIC0_VAR  (*(int *)(0xFFFFF030))
#define VIC1_VAR  (*(int *)(0xFC000030))
#define VIC0_DVAR (*(int *)(0xFFFFF034))
#define VIC1_DVAR (*(int *)(0xFC000034))
#define VIC0_VA0R (*(int *)(0xFFFFF100))
#define VIC0_VA1R (*(int *)(0xFFFFF104))
#define VIC0_VA2R (*(int *)(0xFFFFF108))
#define VIC0_VA3R (*(int *)(0xFFFFF10C))
#define VIC0_VA4R (*(int *)(0xFFFFF110))
#define VIC0_VC0R (*(int *)(0xFFFFF200))
#define VIC0_VC1R (*(int *)(0xFFFFF204))
#define VIC0_VC2R (*(int *)(0xFFFFF208))
#define VIC0_VC3R (*(int *)(0xFFFFF20C))
#define VIC0_VC4R (*(int *)(0xFFFFF210))

#define NOP() asm(" NOP ")
